def partition(A, p, r):
    pivot = A[r]
    i = p-1
    for j in range(p, r):
        if A[j] < pivot:
            i += 1
            A[j], A[i] = A[i], A[j]
    A[i+1], A[r] = A[r], A[i+1]
    return i+1


def median_helper(A, p, r):
    # assumiamo len(A) dispari, c'è un poco di lavoro in più
    # se len(A) è pari
    middle = len(A)//2
    q = partition(A, p, r)
    if q == middle:
        return A[q]
    elif q < middle:
        return median_helper(A, q+1, r)
    else:
        return median_helper(A, p, q-1)


def median(A):
    return median_helper(A, 0, len(A)-1)
